/**
 * //TODO define class
 */
package com.atlassian.crowd.axis.client;

import com.atlassian.crowd.axis.ApplicationAuthenticationContext;
import com.atlassian.crowd.axis.AuthenticatedToken;
import com.atlassian.crowd.axis.PasswordCredential;
import com.atlassian.crowd.axis.SOAPAttribute;
import com.atlassian.crowd.axis.SOAPPrincipal;
import com.atlassian.crowd.axis.SecurityServerHttpBindingStub;
import com.atlassian.crowd.axis.SecurityServerLocator;
import com.atlassian.crowd.axis.ValidationFactor;

import java.util.Date;

public class AxisClientExample
{
    public static void main(String[] argv)
    {
        // connect to the crowd server, using the supplied service URL, similar to http://localhost:8095/crowd/services/SecurityServer?wsdl
        SecurityServerLocator secServer = new SecurityServerLocator();
        secServer.setSecurityServerHttpPortEndpointAddress(secServer.getSecurityServerHttpPortAddress());

        // obtain a reference to the SOAP service, which axis manages.
        SecurityServerHttpBindingStub stub = null;
        try
        {
            stub = (SecurityServerHttpBindingStub) secServer.getSecurityServerHttpPort();

            // authenticate the integrated crowd application
            AuthenticatedToken token = stub.authenticateApplication(new ApplicationAuthenticationContext(
                    new PasswordCredential("password", Boolean.FALSE), "demo",
                    new ValidationFactor[0]));

            // do your custom calls here, eg:
            SOAPPrincipal principal = new SOAPPrincipal();
            principal.setName("test-user");
            principal.setActive(Boolean.TRUE);
            principal.setConception(new Date());
            principal.setAttributes(new SOAPAttribute[]{
                    new SOAPAttribute("mail", new String[]{"test@example.com"}),
                    new SOAPAttribute("givenName", new String[]{"Paul"}),
                    new SOAPAttribute("sn", new String[]{"Smith"})
            });
            stub.addPrincipal(token, principal, new PasswordCredential("secret", Boolean.FALSE));

        }
        catch (Exception e)
        {
            System.err.print(e);
        }
    }
}